//***************************************************************************
//  File........: delay.c
//  Target(s)...: ATmega328p
//  Compiler....: AVR-GCC
//  Description.: Precise Delay Functions (not "timer-dependent")
//                V 0.5, Martin Thomas, 9/2004 See also delay.h
//                Inspired by the avr-libc's loop-code
//                2 Funktionen:
//                delay_us()  siehe delay.h
//                delay_ms()  siehe delay.h
//***************************************************************************

#include <stdint.h> // Integer-Datentypen 8-64bit
#include "delay.h"

void delayloop32(uint32_t loops) 
{
   __asm__ volatile ( "cp  %A0,__zero_reg__ \n\t"  \
                      "cpc %B0,__zero_reg__ \n\t"  \
                      "cpc %C0,__zero_reg__ \n\t"  \
                      "cpc %D0,__zero_reg__ \n\t"  \
                      "breq L_Exit_%=       \n\t"  \
                      "L_LOOP_%=:           \n\t"  \
                      "subi %A0,1           \n\t"  \
                      "sbci %B0,0           \n\t"  \
                      "sbci %C0,0           \n\t"  \
                      "sbci %D0,0           \n\t"  \
                      "brne L_LOOP_%=            \n\t"  \
                      "L_Exit_%=:           \n\t"  \
                      : "=w" (loops)              \
                      : "0"  (loops)              \
                    );                             \
   return;
}
